package com.cool.ling_cha_mount.binary_search;

import java.util.List;

public class Num2856 {
    public int minLengthAfterRemovals(List<Integer> nums) {
        int i = nums.get(nums.size() / 2);
        int start = binarySearch(nums, i);
        int end = binarySearch(nums, i + 1);
        if (end - start > nums.size() / 2) {
            return 2 * (end - start) - nums.size();
        } else {
            return (nums.size() & 1) == 0 ? 0 : 1;
        }
    }

    private int binarySearch(List<Integer> list, int target) {
        int left = -1;
        int right = list.size();
        while (left + 1 < right) {
            int mid = (left + right) >>> 1;
            if (target <= list.get(mid)) {
                right = mid;
            } else {
                left = mid;
            }
        }
        return right;
    }
}
