package com.cool.hot100.binary_tree;


import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/09/01/1:58
 * DayNumber 2
 * Hard 2
 * Level 4
 */
public class Num199 {


    public List<Integer> rightSideView(TreeNode root) {
//        List<Integer> list = new ArrayList<>();
//        dfs(root, list, 0);
//        return list;
        return bfs(root);
    }

    private List<Integer> bfs(TreeNode root) {
        List<Integer> list = new ArrayList<>();
        if (root == null) return list;
        Queue<TreeNode> queue = new LinkedList<>();
        queue.add(root);
        while (!queue.isEmpty()) {
            int size = queue.size();
            for (int i = 0; i < size; i++) {
                TreeNode node = queue.poll();
                if (node != null && node.left != null) {
                    queue.add(node.left);
                }
                if (node != null && node.right != null) {
                    queue.add(node.right);
                }
                if (i == size - 1 && node != null) {
                    list.add(node.val);
                }
            }
        }
        return list;
    }


    //此为dfs解法
    private void dfs(TreeNode root, List<Integer> list, int deep) {
        if (root == null) return;
        if (list.size() == deep) {
            list.add(root.val);
        }
        dfs(root.right, list, ++deep);
        dfs(root.left, list, deep);
    }


}
