package com.cool.ling_cha_mount.binary_search;

/**
 * @author : Cool
 * @date: 2024/11/08
 * 34. 在排序数组中查找元素的第一个和最后一个位置
 */
public class Num34 {
    public int[] searchRange(int[] nums, int target) {
        int start = binarySearch(nums, target);
        if (start < nums.length && nums[start] == target) {
            int end = binarySearch(nums, target + 1) - 1;
            return new int[]{start, end};
        }
        return new int[]{-1, -1};
    }

    public int binarySearch(int[] nums, int target) {
        int left = 0;
        int right = nums.length - 1;
        while (left <= right) {
            int mid = (right - left) / 2 + left;
            if (nums[mid] < target) {
                left = mid + 1;
            } else {
                right = mid - 1;
            }
        }
        return left;
    }
}
